#ifndef MD5_H
#define MD5_H

#define F(x, y, z) (((x) & (y)) | ((~x) & (z)))
#define G(x, y, z) (((x) & (z)) | ((y) & (~z)))
#define H(x, y, z) ((x) ^ (y) ^ (z))
#define I(x, y, z) ((y) ^ ((x) | (~z)))


typedef struct MD5_Context
{
	unsigned int RBuffer[4];
	unsigned int MBuffer[16];
} MD5_Context, MD5_Context_P;

extern unsigned int T[];

void MD5_ProcessMessage(unsigned char * message, 
			unsigned int lengthHigh, 
			unsigned int lengthLow, 
			unsigned char * digest);

MD5_Context * MD5_InitializeContext(void);

void MD5_CalculateDigest(MD5_Context * context);

void MD5_PadMessage(MD5_Context * context, 
		int length, 
		unsigned char * message, 
		unsigned int lengthHigh, 
		unsigned int lengthLow);

void MD5_FillContext(MD5_Context * context, 
		unsigned char * message);

unsigned int MD5_CircularLeftShift(unsigned int number, 
				int bits);

void MD5_HashFunction(unsigned int * a,
		unsigned int b,
		unsigned int c,
		unsigned int d,
		unsigned int x,
		unsigned int t,
		int i,
		int round);

#endif

