#ifndef SHA1_H
#define SHA1_H

typedef struct SHA1_Context
{
	unsigned int HBuffer[5];
	unsigned int Mbuffer[16];
} SHA1_Context, * SHA1_Context_P;

void SHA1_ProcessMessage(unsigned char * message, 
			unsigned int lengthHigh, 
			unsigned int lengthLow, 
			unsigned char * digest);

SHA1_Context * SHA1_InitializeContext(void);

void SHA1_CalculateDigest(SHA1_Context * context);

void SHA1_PadMessage(SHA1_Context * context, 
		int length, 
		unsigned char * message, 
		unsigned int lengthHigh, 
		unsigned int lengthLow);

void SHA1_FillContext(SHA1_Context * context, 
		unsigned char * message);

unsigned int SHA1_FunctionF(int index, 
			unsigned int wordB, 
			unsigned int wordC, 
			unsigned int wordD);

unsigned int SHA1_CircularLeftShift(unsigned int number, 
				int times);

#endif

